/* eslint-disable import/no-extraneous-dependencies */
import React from 'react';
import {
  Title,
  Description,
  Primary,
  ArgsTable,
  PRIMARY_STORY,
} from '@storybook/addon-docs/blocks';
import verifyIcon from '../../../../../storybook-images/verifiedAuthor.svg';
import AuthorTemplateOne from '.';

export default {
  title: 'Theme/Atoms/Author/Template Two',
  component: AuthorTemplateOne,
  argTypes: {
    authorName: {
      control: 'text',
      defaultValue: 'John Doe',
    },
    authorPath: {
      control: 'text',
      defaultValue: 'https://example.com',
    },
    authorImage: {
      control: 'text',
      defaultValue: '1675685947/ellipse-1.png',
    },

    verify: {
      control: 'text',
      defaultValue: verifyIcon,
    },
  },
  parameters: {
    docs: {
      description: {
        component: 'AuthorTemplateOne component',
      },
      page: () => (
        <>
          <Title />
          <Description />
          <Primary />
          <ArgsTable story={PRIMARY_STORY} />
        </>
      ),
    },
  },
};

const Template = (args) => <AuthorTemplateOne {...args} />;

export const Default = Template.bind({});
