/**
 * @name getOperatorData
 * @description Mock data related to the operator
 * @return {Object} operator mock data
 */
export default function getOperatorData(
  statusValue = 'active',
  mainValue = 'Test',
  operatorName = 'Ice Casino',
  ribbonsArr = ['New'],
  oneLiner = '100% Bonus + Big Promotions',
  nrstars = 5
) {
  const operator = {
    pageTemplate: 'operator_review',
    type: 'operator',
    reviewer: {
      image: '1681804760/john-doe.png',
      image_object: {
        url: '1681804760/john-doe.png',
        width: 150,
        height: 150,
      },
      pages_count: 13,
      image_alt: 'Image alt',
      name: 'Ida Moen Olsen',
      author_title: 'Casino Specialist',
      email_address: 'ida_moen@gig.com',
      personal_website: 'https://www.irishluck.ie',
      additional_url: 'https://www.irishluck.ie',
      facebook_profile: 'https://www.facebook.com',
      instagram_profile: 'https://www.instagram.com',
      linkedin_profile: 'https://www.linkedin.com',
      biography: 'Here goes the biography of the author.',
      profile_page_path: '/author/ida-moen',
    },
    template: 'operator_review',
    market: 'ie_en',
    name: operatorName,
    short_name: 'ice-casino',
    ribbons: ribbonsArr,
    updated_at: '2023-09-29 13:56',
    status: 'active',
    one_liners: {
      main: {
        one_liner: 'Welcome Bonus up to £1000',
      },
    },
    featureImg: {
      alt: 'Logo image',
      url: 'https://assets-srv.s3.eu-west-1.amazonaws.com/1673351083/featured-image.png',
      filename: '1673351083/featured-image.png',
    },
    image: {
      alt: '',
      filename: '1651671151/wildz-casino-logo.svg',
      height: '107',
      title: 'image 16.png',
      url: 'https://assets-srv.s3.eu-west-1.amazonaws.com/1651671151/wildz-casino-logo.svg',
      width: '333',
    },
    relation: {
      logo_url_object: {
        alt: 'Logo image for Ice Casino',
        url: 'https://assets-srv.s3.eu-west-1.amazonaws.com/1656682301/1651670626/icecasino-logo.png',
        filename: '1651670626/icecasino-logo.png',
      },
      standardised_logo_url: '/1651670626/icecasino-logo.png',
      minimum_bet: 2,
      minimum_win: 3,
      markets: {
        ie_en: {
          minimum_bet: null,
          minimum_win: null,
        },
      },
      name: operatorName,
      short_name: 'ice-casino',
      rating: '4.5',
      rating_bonuses: '4',
      rating_casino: '4',
      rating_customer: '4',
      rating_games: '4',
      rating_payout: '4',
      status: statusValue,
      links: {
        main: mainValue,
      },
      one_liners: {
        main: {
          one_liner: oneLiner,
        },
      },
      bonus: {
        rating: '4',
        rating_bonuses: '4',
        rating_casino: '4',
        rating_customer: '4',
        rating_games: '4',
        rating_payout: '4',
        currencies: [
          {
            crypto: 0,
            id: 168,
            iso_code: 'ZAR',
            name: 'South Africa Rand',
            symbol: 'R',
          },
        ],
        deposit_methods: [
          {
            id: 1,
            name: 'Visa',
          },
          {
            id: 1,
            name: 'MasterCard',
          },
          {
            id: 1,
            name: 'ApplePay',
          },
        ],
      },
      volatility: 1,
      game_categories: [
        {
          name: 'game name',
        },
      ],
      game_provider: {
        name: 'Rizk',
      },
      launch_date: '2020',
      freespins: 1,
      email: 'hey@casumo.com',
      games_amount: '5000',
      founded: '2012-01-01',
      jackpots: 0,
      winning_lines: '10',
      number_of_reels: '50',
      rtp: null,
      owner: 'Casumo Services Ltd',
      software: [
        {
          id: 2,
          name: '2by2 Gaming',
          short_name: '2_by_2_gaming',
        },
        {
          id: 2,
          name: 'Ash Gaming',
          short_name: 'ash_gaming',
        },
        {
          id: 2,
          name: 'Big Time Gaming',
          short_name: 'big-time_gaming',
        },
        {
          id: 2,
          name: '2by2 Gaming',
          short_name: '2_by_2_gaming',
        },
        {
          id: 2,
          name: 'Ash Gaming',
          short_name: 'ash_gaming',
        },
        {
          id: 2,
          name: 'Big Time Gaming',
          short_name: 'big-time_gaming',
        },
        {
          id: 2,
          name: '2by2 Gaming',
          short_name: '2_by_2_gaming',
        },
        {
          id: 2,
          name: 'Ash Gaming',
          short_name: 'ash_gaming',
        },
        {
          id: 2,
          name: 'Big Time Gaming',
          short_name: 'big-time_gaming',
        },
        {
          id: 2,
          name: '2by2 Gaming',
          short_name: '2_by_2_gaming',
        },
        {
          id: 2,
          name: 'Ash Gaming',
          short_name: 'ash_gaming',
        },
        {
          id: 2,
          name: 'Big Time Gaming',
          short_name: 'big-time_gaming',
        },
      ],
      support_types: '24/7, BitcoinTalk, Email, Facebook, Live chat',
      types: ['casino', 'livecasino', 'sportsbook', 'bonus'],
      url: 'www.ice-casino.com',
    },
    extra_fields: {
      operator_review_summary: `Lorem ipsum dolor sit amet, consectetur adipiscing elit. Tellus proin nunc, nunc est nec mattis augue gravida volutpat. Commodo, volutpat tristique nisl malesuada bibendum quam eu aliquet. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Lacus at neque id dolor diam. Risus purus posuere fermentum justo donec,  consectetur adipiscing elit. . Tortor consectetur faucibus nulla et volutpat tristique nisl malesuada bibendum quam eu aliquet.`,
    },
    numOfStars: nrstars,
  };
  return operator;
}
